/******************************************************************************
* Filename     : cs8900a.c                                                    *
* Program      : loader.                                                      *
* Copyright    : E2G                                                          *
* Author       : Sunyean Jang                                                 *
* Description  : uCOS                                                         *
* Created at   : 2003-12-24                                                   *
* Based on     :                CS8900A device driver.                        *
* Modified by  :                                                              *
* Modified at  :                                                              *
******************************************************************************/
/*   ҽ E2G  uCOS ̴ ̹  Դϴ.
 * StrongARM̳ ARM Ÿٺ忡 ̽ ϸ, Ÿ 32bit μ
 * ̽ մϴ.   ο,  ҽ ؼ ߻ϴ  
 * åӵ  E2G  ʽϴ.
 */

 #include "sa1110.h"
 #include "cs8900a.h"
 
 //***************************************************************************
 // Read data from Packet Page
 //---------------------------------------------------------------------------
 // PARAMETERS : addr -  ּ
 //---------------------------------------------------------------------------
 // RETURN     : شǴ ּ 
 //---------------------------------------------------------------------------
 // ش ּ PacketPage   
 //***************************************************************************
static short ReadDataFromPP(short addr)
 {
 	IO_PPPTR = addr;
 	return IO_PPDATA;
 }
 
 //***************************************************************************
 // Read data from Packet Page
 //---------------------------------------------------------------------------
 // PARAMETERS : addr - ͸  ּ
 //              data -  
 //---------------------------------------------------------------------------
 // RETURN     : void
 //---------------------------------------------------------------------------
 // ش ּ PacketPage ͸ 
 //***************************************************************************
static void WriteDataAtPP(short addr, short data)
 {
 	IO_PPPTR = addr;
 	IO_PPDATA = data;
 	return ;
 }
 
 //***************************************************************************
 //  
 //---------------------------------------------------------------------------
 // PARAMETERS : addr - ͸  ּ
 //              data -  
 //---------------------------------------------------------------------------
 // RETURN     : void
 //---------------------------------------------------------------------------
 //   (polling)
 //***************************************************************************
bool TransmitFrame(short TxLength, void * Data)
 {
        short *endPtr, *s;

        //BufCFG register 8 Ʈ 0̾ ۰ϴ.
        if(ReadDataFromPP(PP_BufCfg)&0x0100 != 0x0100)
        {
             printf("Trasmission is not available.\n");
             return false;
        }

        //1. ɾ 
        WriteDataAtPP(PP_TxCMD,TX_AFTER_ALL);	//IO_TXCMD = TX_AFTER_ALL;

        
        //2.   
        IO_TXLEN = TxLength;


        //3.  Ⱑ   ٸ
        while(ReadDataFromPP(PP_BusST)&0x0100 != 0x0100)
        {
           //ƹ ۾  ʰ ׳  .
        }

        if(DEBUG == true) printf("Transmission is available\n");

        //4. Packet 
        // ̸ŭ ÷  ͸ Ѵ.
 	for (s=Data, endPtr=Data+TxLength; s<endPtr; s++){
		IO_RTX_DATA = *s;
	}

        if(DEBUG == true) printf("All data successed in transmission.\n");

        return true;
  
 }
 
 //***************************************************************************
 //  
 //---------------------------------------------------------------------------
 // PARAMETERS : 
 //              data - Ŷ  ( )
 //---------------------------------------------------------------------------
 // RETURN     : void
 //---------------------------------------------------------------------------
 //   , Datasheet Page 79 ׸ 
 //***************************************************************************
bool ReceiveFrame(void * data)
 {
        short FRLength, isq, count;
        int i;
        char * s;
        bool return_message;

        //ISQ ̺Ʈ ߻ߴٸ
        if(DEBUG == true) printf("ISQ  : %8x\n",IO_ISQ);

        while( (isq = IO_ISQ) != 0x0000 )
        {
              return_message = false;
              if(DEBUG == true) printf("here...1\n");

              //  ̺Ʈ Receive Event
              if( isq & RxEvent == RxEvent )
              {
                   if(DEBUG == true) printf("here...2\n");
                   //  OK
                   if(isq & RxOK == RxOK)   //RxStatus (0x0400) Ȯ 
                   {
                        printf("here...3\n");
                        FRLength = ReadDataFromPP(PP_RxLength);
                        count = FRLength/2 + FRLength%2;
                        MemSet(data,0,MAX_PKT_SIZE);// Ŷ  ΰ  MAX_PKT_SIZE  ٲپ .

                        if(DEBUG == true) printf("Packet Length : %d\n",FRLength);

                        for (i=0, s=data; i<count; i++){
				*((ushort *)s)++ = IO_RTX_DATA;
			}

                        return_message = true;

                   }	
              }
        }
 
 	return return_message;
 }
 //***************************************************************************
 // Ethernet Initialize
 //---------------------------------------------------------------------------
 // PARAMETERS : void
 //---------------------------------------------------------------------------
 // RETURN     : if Success of Initialization
 //---------------------------------------------------------------------------
 // ̴ ȯ   밡  
 //***************************************************************************
 bool EthInit(void)
 {
        int i;

        //Byte Local_MacAddress[8] = {0x00, 0xD0, 0xCA,0xF2, 0x26, 0x25 };

 	// page 19 3.3.3 뿡 ǰ
 	// PacketPagePointer     ԷµǱ  
 	// 3000h ̾ BUS clearϴٴ  ȴ.
 	if (IO_PPPTR != 0x3000)
 	{
 		printf("CS8900A is not confirmed.\n");
 		return false;
 	}
 	
 	// page 42 Product Indentification Code
 	// 0x630E CS8900A Product Code̴.
        if (ReadDataFromPP(PP_ChipID) != 0x630E)
        {
        	printf("EthernetChip is not CS8900A.\n");
        	return false;
        }
        
        //Self Control 
        //WriteDataAtPP(PP_SelfCtl,RESET);
        //while( ! (ReadDataFromPP(PP_SelfST) & INITD) ) ; 
         
        //------------------------------------------------------------
        // Configuration 
        //
        // ̴ Ĩ ϱ   Ѵ.
        //------------------------------------------------------------

        //̴ Ĩ Disable
        WriteDataAtPP(PP_LineCtlReg,0x0000);

        //-----------------------------------------------------
        // ISA    Disable Ѵ.
        //-----------------------------------------------------
        //ISA ͷƮ Disable
        WriteDataAtPP(PP_CS8900_ISAINT,All_Int_High_Impedence);
        
        //ISA DMA Disable
        WriteDataAtPP(PP_CS8900_ISADMA,All_DMA_High_Impedence);
        
        //-----------------------------------------------------
        // Receive 
        //-----------------------------------------------------
        //Receive Configuration and Interrupt Mask 
        WriteDataAtPP(PP_RcvCfgReg,RX_OK_ENBL | RX_CRC_ERROR_ENBL);

        //Receiver Control  : IAHashA | RxOKA | RX_BROADCAST_ACCEPT
        WriteDataAtPP(PP_RcvCtlReg,RX_OK_ACCEPT | RX_IA_ACCEPT | RX_BROADCAST_ACCEPT);
        
        //Full Duplex
        WriteDataAtPP(PP_TestCtlReg,0x4000);

        //-----------------------------------------------------
        // Transmit
        //-----------------------------------------------------
        //Transmitter Configuration : AnycolliE |JabberiE | Out-of-windowiE | TxOKiE | SQErroriE | Loss-of-CRSiE
        WriteDataAtPP(PP_TranCfgReg,TX_ANY_COL_ENBL | TX_JBR_ENBL| TX_LATE_COL_ENBL | TX_OK_ENBL | TX_SQE_ERROR_ENBL
                                    | TX_LOST_CRS_ENBL);

        //Transmitter Command Status 
        //WriteDataAtPP(PP_TranCmdSts,TX_START_ALL_BYTES);


        //Buffer Configuration clear  : Interrupt disalbe
        WriteDataAtPP(PP_BufCfg,0x0000);

        //Bus Control Register  : IOCHRDYE | EnableIRQ set
        WriteDataAtPP(PP_BusCtl,ENABLE_IRQ | IO_CHANNEL_READY_ON);

	// ׽Ʈ  : ׽Ʈ 尡 Ƿ disable
	WriteDataAtPP(PP_TestCtlReg, 0x0000);

        //Transmit Command Request  :   CS8900A  
        WriteDataAtPP(PP_TxCMD, 0x00c0);

        //-----------------------------------------------------
        // EEPROM & Address Filter 
        //-----------------------------------------------------
        //Hash table 32bit 16bit 1 ä
        for ( i = 0 ; i < 4 ; i++ )
        {
            WriteDataAtPP(PP_LAF + i*2 ,0xffff); //Page 88 
        }        
        
        //EEPROM MAC 
        EEPROM_CMD = 0x0200;
        if ( (EEPROM_DATA + 1) == 0xA1 )//First group  : Chip ִ  Ȯ
        {

           printf("EEPROM is attatched.\n");

           for( i = 0 ; i < 3 ; i++ )   //Third group  : MacּҸ ʴ 
           {   
               EEPROM_CMD = 0x0200 | (0x000D + i);          //Command ,
               WriteDataAtPP(PP_IA+2*i,EEPROM_DATA);
               WriteDataAtPP(PP_IA+2*i+1,EEPROM_DATA+1);
               printf("%2x:%2x:",EEPROM_DATA,EEPROM_DATA+1);//Data а........
           }
           printf("\n");

        }else{
        
           //MAC ϱ
           WriteDataAtPP(PP_IA,0x00);
           WriteDataAtPP(PP_IA+1,0xD0);
           WriteDataAtPP(PP_IA+2,0xF2);
           WriteDataAtPP(PP_IA+3,0xCA);
           WriteDataAtPP(PP_IA+4,0x25);
           WriteDataAtPP(PP_IA+5,0x26);	

        }
      
        /*for ( i < 0 ; i < 3 ; i++ )
        {
            WriteDataAtPP(PP_IA + i*2 ,0xffff); //Page 88 
        }*/                

        //̴ Ĩ enable
        WriteDataAtPP(PP_LineCtlReg,SERIAL_RX_ON | SERIAL_TX_ON | AUTO_AUI_10BASET);

        if(DEBUG == true) printf("Ethernet Initialization is successful\n");

        return true;       
 }